#include <fstream>
#include <iostream>
#include <string>
#include <cstring>

#include "pnm.h"
#include "pgm.h"
#include "ppm.h"

void pgm_t::fromppm(const ppm_t& ppm)
{
	float	r, g, b;
	char	*p6, *p5;

  ptype = 5;
  w = ppm.w;
  h = ppm.h;
  bpp = 1;
  max = ppm.max;

  img = new char [bpp * w * h];

  // set up char* pointers for some tasty pointer math
  p6 = ppm.img; p5 = img;

  // loop through color image, convert to float, then do luminance conversion
  for(int i=0;i<w*h;i++) {
    // convert char bytes to float, remember to normalize
    r = (float)*p6++ / (float)max;
    g = (float)*p6++ / (float)max;
    b = (float)*p6++ / (float)max;

    // note that g variable serves double duty here: once as green, then grey
    g = 0.21 * r + 0.72 * g + 0.07 * b;

    // convert float back to char, remembering to scale up to max lum
    *p5++ = (char)(g * (float)max);
  }
}
