#ifndef PNM_H
#define PNM_H

// forward declcarations
// (none)

class pnm_t {
       public:
       // constructors (overloaded)
       pnm_t(const char *file=NULL) : \
                            ptype(0), \
                            w(0), h(0), \
                            bpp(0), max(0), \
                            img(NULL)
                            {
                                   std::ifstream ifs;

                              // watch out for NULL file ptr, use "" instead
                              if(!file) name.assign("");
                              else {
                                name.assign(file);
                                ifs.open(file,std::ios::in|std::ios::binary);
                                if(ifs.good()) ifs >> this;
                                ifs.close();
                              }
                            };

       // copy constructor
       pnm_t(const pnm_t& rhs);

       // destructors
      ~pnm_t()                                         { if(img) {
                                                           delete [] img;
                                                         }
                                                       }

       // friends
friend std::istream& operator>>(std::istream& s, pnm_t& rhs);
friend std::istream& operator>>(std::istream& s, pnm_t *rhs)
                                                       { return(s >> (*rhs)); }
friend std::ostream& operator<<(std::ostream& s, const pnm_t& rhs);
friend std::ostream& operator<<(std::ostream& s, pnm_t *rhs)
                                                       { return(s << (*rhs)); }

       // operators
       const char&       operator[](int i) const       { return img[i]; }
       char&             operator[](int i)             { return img[i]; }

       // assignment operator
       const pnm_t&      operator=(const pnm_t&);

       // members
       std::string       fname()                       { return name; }
       void              rename(const char *file)      { name.assign(file); }

       // private: available to this (base) class and derived classes
       protected:
       int               ptype;
       int               w,h;
       int               bpp;
       int               max;
       std::string       name;
       char             *img;

       // private: only available to this class
       private:
};

#endif
